/*
This sample program utilizes the EasyByte_Software.Cryptocxv7
ActiveX control for PGP Encryption
*/

#INCLUDE "dcdialog.CH"

#Pragma Library("ascom10.lib")


FUNCTION Main()

LOCAL GetList[0], cInputText := '', cOutputText := '', cKeyFolder, cPassword, ;
      cSourceFile, cDestFile, cKeyID, cKeySize, cKeyType, GetOptions, ;
      cEncryptFile, cDecryptFile, cPublicKeyFile

cKeyFolder := Space(50)
cSourceFile := Space(50)
cDestFile := Space(50)
cKeyID := Space(20)
cPassword := Space(20)
cKeySize := '2048'
cKeyType := 'RSA'
cEncryptFile := Space(50)
cDecryptFile := Space(50)
cPublicKeyFile := Space(50)

@ 0,0 DCSAY 'Key Folder' GET cKeyFolder POPUP {|c|DC_PopDir(c)}
@ 1,0 DCSAY 'Key ID' GET cKeyID
@ 2,0 DCSAY 'Key Size' GET cKeySize PICTURE '9999'
@ 3,0 DCSAY 'Key Type:'
@ DCGUI_ROW, DCGUI_COL + 10 DCRADIO cKeyType VALUE 'RSA' PROMPT 'RSA'
@ DCGUI_ROW, DCGUI_COL + 10 DCRADIO cKeyType VALUE 'DH/DSS' PROMPT 'DH/DSS'
@ 4,0 DCSAY 'Password' GET cPassword

@ 5.5,0 DCPUSHBUTTON CAPTION "Generate Keys" SIZE 20,1 ;
   ACTION {||GenerateKeys( cKeyFolder, cKeyID, cKeySize, cKeyType, cPassword) } ;
   WHEN {||!Empty(cKeyFolder) .AND. !Empty(cKeyID) .AND. !Empty(cKeySize) .AND. ;
           !Empty(cKeyType) .AND. !Empty(cPassword)}

@ 8,0 DCSAY 'Source File' GET cSourceFile POPUP {|c|DC_PopFile(c)}
@ 9,0 DCSAY 'Destination File' GET cDestFile POPUP {|c|DC_PopFile(c)}

@ 10.5,0 DCPUSHBUTTON CAPTION "Encrypt File" SIZE 20,1 ;
   ACTION {||EncryptFile( cPublicKeyFile, cSourceFile, cDestFile ) } ;
   WHEN {||!Empty(cPublicKeyFile, cSourceFile, cDestFile )}

@ 13,0 DCSAY 'Source File' GET cEncryptFile POPUP {|c|DC_PopFile(c)}
@ 14,0 DCSAY 'Destination File' GET cDecryptFile POPUP {|c|DC_PopFile(c)}

@ 15.5,0 DCPUSHBUTTON CAPTION "Decrypt File" SIZE 20,1 ;
   ACTION {||DecryptFile( cKeyFolder, cPassword, cEncryptFile, cDecryptFile ) } ;
   WHEN {||!Empty(cKeyFolder) .AND. !Empty(cPassword) .AND. !Empty(cEncryptFile) ;
            .AND. !Empty(cDecryptFile)}

@ 18,0 DCSAY 'Public Key File' GET cPublicKeyFile POPUP {|c|DC_PopFile(c)}

@ 19.5,0 DCPUSHBUTTON CAPTION "Add to Key Ring File" SIZE 20,1 ;
   ACTION {||ImportPublicKey( cKeyFolder, cPublicKeyFile, cKeyID ) } ;
   WHEN {||!Empty(cKeyFolder) .AND. !Empty(cPublicKeyFile) .AND. !Empty(cKeyID)}

DCGETOPTIONS SAYRIGHTBOTTOM SAYWIDTH 120 TABSTOP

DCREAD GUI FIT TITLE 'PGP Encryption Test Program' OPTIONS GetOptions

RETURN nil

* ----------

PROC appsys ; RETURN

* ----------

STATIC FUNCTION GenerateKeys( cKeyFolder, cKeyID, cKeySize, cKeyType, cPassword )

LOCAL oCryptocx, cStatus

oCryptocx := CreateObject('EasyByte_Software.Cryptocxv7')

IF oCryptocx == NIL
  DCMSGBOX 'Could not create Active-X component:', ;
   'EasyByte_Software.Cryptocxv7' ;
    FONT '12.Lucida Console'
  RETURN .f.
ENDIF

oCryptocx:password := Alltrim(cPassword)
oCryptocx:keyID := Alltrim(cKeyID)
oCryptocx:keySize := cKeySize
oCryptocx:keyType := cKeyType
oCryptocx:keyFolder := Alltrim(cKeyFolder)
oCryptocx:licenseKey := 'DEMO'

cStatus := oCryptocx:PGPGenKeys()

oCryptocx:destroy()

IF cStatus == 'TRUE'
  DCMSGBOX 'Key generation went well with no errors.'
ELSE
  DCMSGBOX cStatus
ENDIF

RETURN cStatus

* ----------

STATIC FUNCTION EncryptFile( cPublicKeyFile, cSourceFile, cDestFile )

LOCAL oCryptocx, cStatus, cEncryptString

oCryptocx := CreateObject('EasyByte_Software.Cryptocxv7')

IF oCryptocx == NIL
  DCMSGBOX 'Could not create Active-X component:',;
    'EasyByte_Software.Cryptocxv7' ;
    FONT '12.Lucida Console'
  RETURN .f.
ENDIF

oCryptocx:workingFolder := 'C:\'
oCryptocx:inputText := MemoRead(Alltrim(cSourceFile))
oCryptocx:publicKey := MemoRead(Alltrim(cPublicKeyFile))
oCryptocx:licenseKey := 'DEMO'

cEncryptString := oCryptocx:PGPEncryptString()

MemoWrit( cDestFile, cEncryptString )

oCryptocx:destroy()

/*
IF cStatus == 'TRUE'
  DCMSGBOX 'Encryption went well with no errors.'
ELSE
  DCMSGBOX cStatus
ENDIF
*/

RETURN cEncryptString

* ----------

STATIC FUNCTION DecryptFile( cKeyFolder, cPassword, cEncryptFile, cDecryptFile )

LOCAL oCryptocx, cStatus

oCryptocx := CreateObject('EasyByte_Software.Cryptocxv7')

IF oCryptocx == NIL
  DCMSGBOX 'Could not create Active-X component:',;
    'EasyByte_Software.Cryptocxv7' ;
    FONT '12.Lucida Console'
  RETURN .f.
ENDIF

oCryptocx:keyFolder := Alltrim(cKeyFolder)
oCryptocx:sourceFile := Alltrim(cEncryptFile)
oCryptocx:destinationFile := Alltrim(cDecryptFile)
oCryptocx:password := Alltrim(cPassword)
oCryptocx:licenseKey := 'DEMO'

cStatus := oCryptocx:PGPFileDecrypt()

oCryptocx:destroy()

IF cStatus == 'TRUE'
  DCMSGBOX 'Decryption went well with no errors.'
ELSE
  DCMSGBOX cStatus
ENDIF

RETURN cStatus

* ----------

STATIC FUNCTION ImportPublicKey( cKeyFolder, cPublicKeyFile, cKeyID )

LOCAL oCryptocx, cStatus

oCryptocx := CreateObject('EasyByte_Software.Cryptocxv7')

IF oCryptocx == NIL
  DCMSGBOX 'Could not create Active-X component:',;
    'EasyByte_Software.Cryptocxv7' ;
    FONT '12.Lucida Console'
  RETURN .f.
ENDIF

oCryptocx:keyFolder := Alltrim(cKeyFolder)
oCryptocx:publicKey := Alltrim(cPublicKeyFile)
oCryptocx:keyID := Alltrim(cKeyID)
oCryptocx:licenseKey := 'DEMO'

cStatus := oCryptocx:PGPAddKeyToKeyRing()

oCryptocx:destroy()

IF cStatus == 'TRUE'
  DCMSGBOX 'Key Import went well with no errors.'
ELSE
  DCMSGBOX cStatus
ENDIF

RETURN cStatus

