/*
This sample program utilizes the EasyByte_Software.Cryptocxv7
ActiveX control for PGP Encryption

Dim Cryptocx As New EasyByte_Software.Cryptocxv7

 Cryptocx.LicenseKey = "DEMO"

 Cryptocx.KeyFolder = txtPGPSecRing.Text
 Cryptocx.Password = txtPGPDecryptPassword.Text
 Cryptocx.InputText = txtPGPText.Text
 txtDecryptedPGPText.Text = Cryptocx.PGPDecryptString
*/


#INCLUDE "dcdialog.CH"

#Pragma Library("ascom10.lib")


FUNCTION Main()

LOCAL GetList[0], cInputText := '', cOutputText := '', cKeyFolder, cPassword, ;
      cSourceFile, cDestFile, cKeyID, cKeySize, cKeyType, GetOptions

cKeyFolder := Space(50)
cSourceFile := Space(50)
cDestFile := Space(50)
cKeyID := Space(20)
cPassword := Space(20)
cKeySize := '2048'
cKeyType := 'RSA'

@ 0,0 DCSAY 'Key Folder' GET cKeyFolder POPUP {|c|DC_PopDir(c)}
@ 1,0 DCSAY 'Key ID' GET cKeyID
@ 2,0 DCSAY 'Key Size' GET cKeySize PICTURE '9999'
@ 3,0 DCSAY 'Key Type:'
@ DCGUI_ROW, DCGUI_COL + 10 DCRADIO cKeyType VALUE 'RSA' PROMPT 'RSA'
@ DCGUI_ROW, DCGUI_COL + 10 DCRADIO cKeyType VALUE 'DH/DSS' PROMPT 'DH/DSS'
@ 4,0 DCSAY 'Password' GET cPassword

@ 5.5,0 DCPUSHBUTTON CAPTION "Generate Keys" SIZE 20,1 ;
   ACTION {||GenerateKeys( cKeyFolder, cKeyID, cKeySize, cKeyType, cPassword) } ;
   WHEN {||!Empty(cKeyFolder) .AND. !Empty(cKeyID) .AND. !Empty(cKeySize) .AND. ;
           !Empty(cKeyType) .AND. !Empty(cPassword)}

@ 8,0 DCSAY 'Source File' GET cSourceFile POPUP {|c|DC_PopFile(c)}
@ 9,0 DCSAY 'Destination File' GET cDestFile POPUP {|c|DC_PopFile(c)}

@ 10.5,0 DCPUSHBUTTON CAPTION "Generate File" SIZE 20,1 ;
   ACTION {||GenerateFile( cKeyFolder, cKeyID, cSourceFile, cDestFile ) }

DCGETOPTIONS SAYRIGHTBOTTOM SAYWIDTH 120 TABSTOP

DCREAD GUI FIT TITLE 'PGP Encryption Test Program' OPTIONS GetOptions

RETURN nil

* ----------

PROC appsys ; RETURN

* ----------

STATIC FUNCTION GenerateKeys( cKeyFolder, cKeyID, cKeySize, cKeyType, cPassword )

LOCAL oCryptocx, cStatus

oCryptocx := CreateObject('EasyByte_Software.Cryptocxv7')

IF oCryptocx == NIL
  DCMSGBOX 'Could not create Active-X component:', ;
   'EasyByte_Software.Cryptocxv7' ;
    FONT '12.Lucida Console'
  RETURN .f.
ENDIF

oCryptocx:password := Alltrim(cPassword)
oCryptocx:keyID := Alltrim(cKeyID)
oCryptocx:keySize := cKeySize
oCryptocx:keyType := cKeyType
oCryptocx:keyFolder := Alltrim(cKeyFolder)
oCryptocx:licenseKey := 'DEMO'

cStatus := oCryptocx:PGPGenKeys()

oCryptocx:destroy()

IF cStatus == 'TRUE'
  DCMSGBOX 'Key generation went well with no errors.'
ELSE
  DCMSGBOX cStatus
ENDIF

RETURN cStatus

* ----------

STATIC FUNCTION GenerateFile( cKeyFolder, cKeyID, cSourceFile, cDestFile )

LOCAL oCryptocx, cStatus

oCryptocx := CreateObject('EasyByte_Software.Cryptocxv7')

IF oCryptocx == NIL
  DCMSGBOX 'Could not create Active-X component:',;
    'EasyByte_Software.Cryptocxv7' ;
    FONT '12.Lucida Console'
  RETURN .f.
ENDIF

oCryptocx:keyFolder := Alltrim(cKeyFolder)
oCryptocx:sourceFile := Alltrim(cSourceFile)
oCryptocx:destinationFile := Alltrim(cDestFile)
oCryptocx:keyID := Alltrim(cKeyID)
oCryptocx:asciiArmour := "yes"
oCryptocx:licenseKey := 'DEMO'

cStatus := oCryptocx:PGPFileEncrypt()

oCryptocx:destroy()

IF cStatus == 'TRUE'
  DCMSGBOX 'Encryption went well with no errors.'
ELSE
  DCMSGBOX cStatus
ENDIF

RETURN cStatus

